package io.tswf.groovy.bettergroovy.asm.expansion.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMethodMetadata
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
class ConflictingMethodFoundException extends RuntimeException implements IConflictResolveExceptionBypassMarker {
    ExpansionMethodMetadata expansionMethodMeta
    ClassNode targetClass
    MethodNode conflictingMethod

    ConflictingMethodFoundException(ExpansionMethodMetadata expansionMethodMeta, ClassNode targetClass, MethodNode conflictingMethod) {
        super("The method ${conflictingMethod.javaFullName} is already exist in ${targetClass.javaName}, can't inject from ${expansionMethodMeta.expansion.expansionClass.javaName}!")
        this.expansionMethodMeta = expansionMethodMeta
        this.targetClass = targetClass
        this.conflictingMethod = conflictingMethod
    }
}
