package io.tswf.groovy.bettergroovy.asm.expansion.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMetadata
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMethodMetadata

@CompileStatic
class InvalidExpansionMethodException extends RuntimeException {
    ExpansionMethodMetadata expansionMethodMeta

    InvalidExpansionMethodException(String message, ExpansionMethodMetadata expansionMethodMeta) {
        super("The expansion method ${expansionMethodMeta.expansionMethod.javaFullName} in ${expansionMethodMeta.expansion.expansionClass.javaName} is invalid because ${message}")
        this.expansionMethodMeta = expansionMethodMeta
    }
}
