package io.tswf.groovy.bettergroovy.asm.expansion.generator.conflict

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionConflictResolveStrategy
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

interface IConflictResolveStrategyLogic {
    void handleConflictResolve(ConflictResolveContext context)

    ExpansionConflictResolveStrategy getEnumValue()
}

@CheckedMapConstructor
@CompileStatic
class ConflictResolveContext {
    ExpansionMethodMetadata expansionMethodMeta
    ClassNode targetClass
    MethodNode conflictingMethod
    boolean canContinue = false
}