package io.tswf.groovy.bettergroovy.asm.expansion.reader.exclusion

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import groovy.transform.Generated
import groovy.transform.Internal
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMetadata
import org.objectweb.asm.Type
import org.objectweb.asm.tree.MethodNode

@AutoService(IExpansionCustomExclusion)
@CompileStatic
class GroovyObjectCustomExclusion implements IExpansionCustomExclusion {

    @Override
    boolean isNeedsToExcludeMethod(ExpansionMetadata expansionMeta, MethodNode expansionMethodCandidate) {
        return expansionMethodCandidate.hasAnnotation(Internal) || expansionMethodCandidate.hasAnnotation(Generated)
    }

    @Override
    boolean isNeedsToExcludeInterface(ExpansionMetadata expansionMeta, Type interfaceType) {
        return interfaceType == GroovyObject.asAsmType()
    }
}
