package io.tswf.groovy.bettergroovy.asm.expansion.reader.exclusion

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.expansion.meta.ExpansionMetadata
import lombok.Generated
import org.objectweb.asm.Type
import org.objectweb.asm.tree.MethodNode


@AutoService(IExpansionCustomExclusion)
@CompileStatic
class LombokGeneratedCustomExclusion implements IExpansionCustomExclusion {

    static final Type LOMBOK_GENERATED_TYPE = Type.getObjectType("lombok/Generated")

    @Override
    boolean isNeedsToExcludeMethod(ExpansionMetadata expansionMeta, MethodNode expansionMethodCandidate) {
        return expansionMethodCandidate.hasAnnotation(LOMBOK_GENERATED_TYPE)
    }
}
